#pragma once

enum MachineArch
{
    x64,
    X86        
};

enum OsVersion
{
    Win2003,
    Win2008        
};


class CInstall
{
private:
    MachineArch m_Arch;
    OsVersion   m_OsVer;

    bool UnixTools();    
    bool Zip();
    bool DbgView();
    bool Gvim();
    bool svn();
    bool putty();
    
    bool ActiceTcl();
    bool SourceInsight();

    bool WDK();
    bool SDK();
    
    bool WSD_hotfix();
    bool WireShark();

    bool VistaBoot();

    bool Python();
    bool CpyPythonLib();
    bool PythonExtention();
    bool MakeSDK_ShortCUt();
    bool WMI();      

public:
    //
    //  Constructor
    CInstall(MachineArch Arch, OsVersion OsVer);

    bool DoInstall();
    BOOL Reboot();

};

