import sys
import os

def change_guid2lid(guid):
	guid2lid_file = os.environ["temp"] + os.sep + "guid2lid"
	#print (guid2lid_file)
	try:
		fd = open(guid2lid_file)
		list = fd.readlines()
		fd.close()
	except Exception, e:
		print "Caught Exception " + str(e)
		print "Probably File " + guid2lid_file + " does not exist"
		sys.exit(2)
	min = {}	
	max = {}	
	guid_str = {}	
	maximum = 0
	for line in list:
		words = line.split()
		if len(words) > 0:
			try:
				curr_guid = eval(words[0])
				min[curr_guid] = eval(words[1])
				eval_curr_max = eval(words[2])
				max[curr_guid] = eval_curr_max
				guid_str[curr_guid] = words[0]
			except Exception, e:
				print "Caught Exception " + str(e)
				print "Probably " + words[0] + " or ",
				print words[1] + " or ",
				print words[2] + " in " + guid2lid_file + " is not a number"
				sys.exit(3)

			if eval_curr_max > maximum:
				maximum = eval_curr_max

	for delta in range(0, 3):
	#	print delta
	#	print delta+guid
		if min.has_key(guid+delta):
	#		print "Found " + str(guid+delta)
			num = max[guid+delta] - min[guid+delta]
			min[guid+delta] = maximum + 1
			max[guid+delta] = maximum + 1 + num
			maximum = maximum + 1 + num

	#print "GUIDS:"
	#print str(guid_str)
	#print "MIN:"
	#print str(min)
	#print "MAX:"
	#print str(max)
		
	try:
		out_file = open(guid2lid_file + ".new", 'w+t')
		for k in guid_str.keys():
			#print guid_str[k] + " " + hex(min[k]) + " " + hex(max[k])
			#print
			out_file.write(guid_str[k] + " " + hex(min[k]) + " " + hex(max[k]) + "\n")
			out_file.write("\n")
		out_file.flush()
		out_file.seek(0)
		out_file.close()
		os.system("move " + guid2lid_file + ".new " + guid2lid_file)
	except Exception, e:
		print("Writing to file failed Exception %s " % str(e));



cmd = "vstat.exe"
try:
	fd = os.popen(cmd)
	output = fd.readlines()
	rc = fd.close()
except Exception, e:
	print "vstat failed"
	sys.exit(1)

guid = 0
#print str(output)
for line in output:
	if "node_guid=" in line: 
		words = line.split("=")
		#print(words[1])
		parts = words[1].split(":")
		try:
			guid_str = "0x" + parts[0] + parts[1] + parts[2] + parts[3]
			#print guid_str
			guid = eval(guid_str);
			#print guid
			if guid <= 0:
				print "no guid was found"
				sys.exit(5)
			change_guid2lid(guid)
		except Exception, e:
			print "no guid in vstat"
			sys.exit(4)


#print str(output)
if len(sys.argv) == 2 and sys.argv[1] == "/runsm":
	os.system("opensm.exe")
sys.exit(0)

