static    KIRQL OldLevel;
#define SPIN_LOCK_INITIALIZE(lock) \
    *lock = 0;

#define SPIN_LOCK_ACQUIRE_PASSIVE(lock) \
    KeRaiseIrql (DISPATCH_LEVEL, &OldLevel); \
    while(_InterlockedCompareExchange(lock, 1, 0));


#define SPIN_LOCK_RELEASE_PASSIVE(lock) \
    _InterlockedCompareExchange(lock, 0, 1);\
    KeLowerIrql(PASSIVE_LEVEL);


#define SPIN_LOCK_ACQUIRE_DPC(lock) \
    while(_InterlockedCompareExchange(lock, 1, 0));

#define SPIN_LOCK_RELEASE_DPC(lock) \
    _InterlockedCompareExchange(lock, 0, 1);