import _winreg
import sys

def FindAdapterGuidByName(AdapterName):
    key = _winreg.OpenKey (_winreg.HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Network\\{4D36E972-E325-11CE-BFC1-08002BE10318}", 0, _winreg.KEY_READ)
    i = 0
    while True:
        try:
           AdapterKeyName = _winreg.EnumKey (key, i)
           AdapterKey = _winreg.OpenKey(key, AdapterKeyName,0 , _winreg.KEY_READ)
           try:
               Connection = _winreg.OpenKey(AdapterKey, "Connection",0 , _winreg.KEY_READ)
           except EnvironmentError:
               i += 1
               continue

           CurrentAdapterName , type = _winreg.QueryValueEx(Connection, "Name");
           if CurrentAdapterName == AdapterName:
              return AdapterKeyName
           i += 1
        except EnvironmentError:
           break

def FindAdapterByGuid (AdapterGuid):
    key = _winreg.OpenKey (_winreg.HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\class\\{4D36E972-E325-11CE-BFC1-08002BE10318}", 0, _winreg.KEY_READ)
    i = 0
    while True:
        try:
           AdapterKeyName = _winreg.EnumKey (key, i)
           AdapterKey = _winreg.OpenKey(key, AdapterKeyName,0 , _winreg.KEY_READ | _winreg.KEY_WRITE)
           try:
               NetCfgInstanceId , type = _winreg.QueryValueEx(AdapterKey, "NetCfgInstanceId");
               if AdapterGuid == NetCfgInstanceId:
                   return AdapterKey
           except EnvironmentError:
               pass
        except EnvironmentError:
           print "error"
           return
        i+= 1

def SetAdapterValue(AdapterKey, name, value):
    _winreg.SetValueEx(AdapterKey, name, 0, _winreg.REG_SZ, value)

def usage():
    print "Usage of program:"
    print sys.argv[0] + "<adapter name> <enableppp / disableppp>"
    print "example: " + sys.argv[0] + " \"Local Area Connection 6\" enableppp"



if __name__ == '__main__':
    if len(sys.argv) !=3:
        usage()
        sys.exit(1)

    if sys.argv[2] != "enableppp" and sys.argv[2] != "disableppp":
        usage()
        sys.exit(1)

    AdapterGuid = FindAdapterGuidByName(sys.argv[1])
    if AdapterGuid == None:
        print "Error (1) - wrong adapter name"
        usage()
        sys.exit(1)


    AdaptherKey = FindAdapterByGuid (AdapterGuid)
    if AdaptherKey == None:
        print "Error (2) - wrong adapter name"
        usage()
        sys.exit(1)
    
    if sys.argv[2] == "enableppp":
        SetAdapterValue(AdaptherKey , "PerPriTxPause", "255")
        SetAdapterValue(AdaptherKey , "PerPriRxPause", "255")
        SetAdapterValue(AdaptherKey , "TxPause", "0")
        SetAdapterValue(AdaptherKey , "RxPause", "0")
    else:
        SetAdapterValue(AdaptherKey , "PerPriTxPause", "0")
        SetAdapterValue(AdaptherKey , "PerPriRxPause", "0")

    print "Script has finished successfuly: Please don't forget to restart adapter before testing"
