#!/usr/bin/perl -w

process_file("nttcp/1sockets/ntttcp_full");
process_file("nttcp/2sockets/ntttcp_full");
process_file("nttcp/4sockets/ntttcp_full");


sub process_file {
	my $filename = shift;
	my $msg_sz = 1;
	
	open FD, $filename;  
	
	#Total Bytes(MEG) Realtime(s) Average Frame Size Total Throughput(Mbit/s)

	print "Filename: $filename\n\n";

	print "msg-size, bytes, time, bw_calc, bw_ntttcp, cpu\n";

	while ( <FD> )
	{
		if (! m/^Total Bytes/)  { next ; }

       		$_=<FD>;
       		$_=<FD>;
        	$_=<FD>;

		my @line= split /\s+/ ;
		my $bytes = $line[1];
		my $time = $line[2];
		my $bw = $line[4]/8;
		my $bw_calc = $bytes/$time;

		
        	$_=<FD>;
        	$_=<FD>;
        	$_=<FD>;
        	$_=<FD>;
        	$_=<FD>;
        	$_=<FD>;
        	$_=<FD>;
        	$_=<FD>;
        	$_=<FD>;
        	$_=<FD>;
        	$_=<FD>;
        	$_=<FD>;
 
		@line= split /\s+/ ;
		my $cpu = $line[5];

		#print "bytes=$bytes time=$time bw=$bw bw_calc=$bw_calc cpu=$cpu\n";

		print "$msg_sz, $bytes, $time, $bw_calc, $bw, $cpu\n";
		#print $_;	

		$msg_sz <<= 1;


	};

	close FD;

	print "\n\n\n";
}

