import os
import platform
import subprocess


build_type = "chk"           # can be chk / fre
build_location = "q:\\projinf3\\trunk"


##################################
### run_cmd
################################## 
def run_cmd(cmd):

    try:
        pipe = subprocess.Popen(cmd, False)
        rc = pipe.wait()
        if rc != 0:
            script_exit("Cmd '%s' failed, rc=%s" % (cmd, rc))
    except OSError, e:    
        script_exit("Cmd '%s' failed, error=%s" % (cmd, os.strerror(e.errno)))


###################
# script_exit
###################
def script_exit(err, exit_code=1):

    print err
    sys.exit(exit_code)

##################
# is_64_bits_machine
##################
def is_64_bits_machine():

   path =os.getenv('windir') + "\\SysWOW64"
   return os.path.exists(path)


# work according to version
if build_type == "chk" :
    if platform.version()[0] == "6" :
        if is_64_bits_machine():
            dest_str = "objchk_wlh_amd64\\amd64"
        else:
            dest_str = "objchk_wlh_x86\\i386"
    else:
        if is_64_bits_machine():
            dest_str = "objchk_wnet_amd64\\amd64"
        else:
            dest_str = "objchk_wnet_x86\\i386"
else:
    # free build
    if platform.version()[0] == "6" :
        if is_64_bits_machine():
            dest_str = "objfre_wlh_amd64\\amd64"
        else:
            dest_str = "objfre_wlh_x86\\i386"
    else:
        if is_64_bits_machine():
            dest_str = "objfre_wnet_amd64\\amd64"
        else:
            dest_str = "objfre_wnet_x86\\i386"

if is_64_bits_machine():
    print "is_64_bits_machine() returned true"
    cmd = "\\\\labfs01\\swgwork\\tzachid\\cmd64.exe"
else:
    print "is_64_bits_machine() returned  false"
    cmd = "cmd"

command = cmd + " /c xcopy.exe /y " + build_location + "\\bin\\kernel\\" + dest_str +"\\mlx4*.sys %windir%\\system32\\drivers"
print command
run_cmd(command)